<script>
import {useLayout} from '@/layout/composables/layout';
import {ref, computed} from 'vue';
import AppConfig from '@/layout/AppConfig.vue';
import {HOST_API} from "@/vars";

const {layoutConfig} = useLayout();
const checked = ref(false);


export default {
  data: () => ({
    username: 'jose',
    email: 'jose@correo.com',
    password_show: false,
    password: 'jose123.',
    role: null
  }),

  computed: {
    // a computed getter
    logoUrl() {
      // `this` points to the component instance
      return `layout/images/${layoutConfig.darkTheme.value ? 'logo-white' : 'logo-dark'}.svg`
    }
  },
  methods: {
    submit() {
      this.createUser()
    },
    createUser() {
      fetch(HOST_API + '/api/auth/users/', {
        method: 'POST',
        body: JSON.stringify({
          username: this.username,
          email: this.email,
          password: this.password,
        }),
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => res.json())
          .catch(error => console.error('Error:', error))
          .then(response => {
            console.log(response)
            this.onRegister()
          });
    },

    onRegister() {
      fetch(HOST_API + '/api/authentication/register/', {
        method: 'POST',
        body: JSON.stringify({
          username: this.username,
          email: this.email,
          role: this.role
        }),
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        res.json()
      })
          .catch(error => console.error('Error:', error))
          .then(response => {
            this.LoginUser()
          });
    },

    LoginUser() {
      fetch(HOST_API + '/api/token/', {
        method: 'POST',
        body: JSON.stringify({username: this.username, password: this.password}),
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => res.json())
          .catch(error => console.error('Error:', error))
          .then(response => {
            this.$store.state.authentication = response;
            this.$store.commit('login');
            this.$router.push({name: 'dashboard'});
          });
    },
  },
}


</script>

<template>
  <div class="surface-ground flex align-items-center justify-content-center min-h-screen min-w-screen overflow-hidden">
    <div class="flex flex-column align-items-center justify-content-center">
      <img :src="logoUrl" alt="Sakai logo" class="mb-5 w-6rem flex-shrink-0"/>
      <div
          style="border-radius: 56px; padding: 0.3rem; background: linear-gradient(180deg, var(--primary-color) 10%, rgba(33, 150, 243, 0) 30%)">
        <div class="w-full surface-card py-8 px-5 sm:px-8" style="border-radius: 53px">
          <div class="text-center mb-5">
            <img src="/demo/images/login/avatar.png" alt="Image" height="50" class="mb-3"/>
            <div class="text-900 text-3xl font-medium mb-3">Bientenido!</div>

            <span v-if="role" class="text-600 font-medium">Completa los campos para poder continuar</span>
            <span v-else class="text-600 font-medium">Por favor selecciona un rol</span>
          </div>

          <div v-if="role">
            <label for="username" class="block text-900 text-xl font-medium mb-2">Nombre de usuario</label>
            <InputText id="username" type="text" placeholder="Email address" class="w-full md:w-30rem mb-5"
                       style="padding: 1rem" v-model="username"/>

            <label for="email" class="block text-900 text-xl font-medium mb-2">Correo</label>
            <InputText id="email" type="text" placeholder="Email address" class="w-full md:w-30rem mb-5"
                       style="padding: 1rem" v-model="email"/>

            <label for="password" class="block text-900 font-medium text-xl mb-2">Contraseña</label>
            <Password id="password" v-model="password" placeholder="Password" :toggleMask="true" class="w-full mb-3"
                      inputClass="w-full" inputStyle="padding:1rem"></Password>


            <Button @click="submit" label="Registrarme" class="w-full p-3 text-xl"></Button>

            <div class="flex align-items-center justify-content-between mt-5 gap-5">
              <div class="flex align-items-center">
                Ya tengo una cuenta,
                <router-link :to="{'name': 'login'}"
                             class="font-medium no-underline ml-2 text-right cursor-pointer"
                             style="color: var(--primary-color)">
                  Iniciar sesión
                </router-link>
              </div>
            </div>
          </div>
          <div v-else>
            <div class="grid">
              <div class="col-12 md:col-6">
                <div class="field-radiobutton mb-0">
                  <RadioButton id="option1" name="option" value="evaluator" v-model="role"/>
                  <label for="option1">Calificador</label>
                </div>
              </div>
              <div class="col-12 md:col-6">
                <div class="field-radiobutton mb-0">
                  <RadioButton id="option2" name="option" value="writer" v-model="role"/>
                  <label for="option2">Escritor</label>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
.pi-eye {
  transform: scale(1.6);
  margin-right: 1rem;
}

.pi-eye-slash {
  transform: scale(1.6);
  margin-right: 1rem;
}
</style>
